#include <avr/io.h>

#include "usart.h"

//----------------------------------------------------------------------
void usartInit(unsigned int ubrr)
{
	UBRRH = (unsigned char)(ubrr >> 8);
	UBRRL = (unsigned char) ubrr;
	
	UCSRB = _BV(RXEN) | _BV(TXEN);
	UCSRC = _BV(URSEL) | _BV(UCSZ1) | _BV(UCSZ0);
}

//----------------------------------------------------------------------
void usartPutChar(unsigned char data)
{
	loop_until_bit_is_set(UCSRA,UDRE);
	
  UDR = data;
  if(data == '\n')
  {
    usartPutChar('\r');
  }
}

//----------------------------------------------------------------------
void usartPutStr(char *str)
{
	unsigned int i = 0;
	
	for(i=0;str[i];i++)
		usartPutChar((unsigned char) str[i]);
}

//----------------------------------------------------------------------
unsigned char usartGetChar(void)
{
  unsigned char data = 0;

  while(!(UCSRA & _BV(RXC)));

  data = UDR;

	return data;
}
